#ifndef __S2_DYNAMIC_PRESET2_H__
#define __S2_DYNAMIC_PRESET2_H__


/*
* DIGITAL_INPUT
*/
#define __S2_dynamic_preset2_RECALL_DIG_INPUT 0
#define __S2_dynamic_preset2_SAVE_DIG_INPUT 1
#define __S2_dynamic_preset2_DELETE_DIG_INPUT 2


/*
* ANALOG_INPUT
*/

#define __S2_dynamic_preset2_PATH$_STRING_INPUT 0
#define __S2_dynamic_preset2_PATH$_STRING_MAX_LEN 64
CREATE_STRING_STRUCT( S2_dynamic_preset2, __PATH$, __S2_dynamic_preset2_PATH$_STRING_MAX_LEN );
#define __S2_dynamic_preset2_FILENAME$_STRING_INPUT 1
#define __S2_dynamic_preset2_FILENAME$_STRING_MAX_LEN 32
CREATE_STRING_STRUCT( S2_dynamic_preset2, __FILENAME$, __S2_dynamic_preset2_FILENAME$_STRING_MAX_LEN );


#define __S2_dynamic_preset2_LEVEL_IN_ANALOG_INPUT 2
#define __S2_dynamic_preset2_LEVEL_IN_ARRAY_LENGTH 200

/*
* DIGITAL_OUTPUT
*/
#define __S2_dynamic_preset2_RECALL_OK_DIG_OUTPUT 0
#define __S2_dynamic_preset2_RECALL_ERROR_DIG_OUTPUT 1
#define __S2_dynamic_preset2_SAVE_OK_DIG_OUTPUT 2
#define __S2_dynamic_preset2_SAVE_ERROR_DIG_OUTPUT 3
#define __S2_dynamic_preset2_DELETE_OK_DIG_OUTPUT 4
#define __S2_dynamic_preset2_DELETE_ERROR_DIG_OUTPUT 5


/*
* ANALOG_OUTPUT
*/


#define __S2_dynamic_preset2_LEVEL_OUT_ANALOG_OUTPUT 0
#define __S2_dynamic_preset2_LEVEL_OUT_ARRAY_LENGTH 200



/*
* INTEGER
*/


/*
* LONG_INTEGER
*/


/*
* SIGNED_INTEGER
*/


/*
* SIGNED_LONG_INTEGER
*/


/*
* STRING
*/
#define __S2_dynamic_preset2_M_SFILENAME_STRING_MAX_LEN 96
CREATE_STRING_STRUCT( S2_dynamic_preset2, __M_SFILENAME, __S2_dynamic_preset2_M_SFILENAME_STRING_MAX_LEN );

/*
* STRUCTURE
*/

START_GLOBAL_VAR_STRUCT( S2_dynamic_preset2 )
{
   void* InstancePtr;
   struct GenericOutputString_s sGenericOutStr;
   unsigned short LastModifiedArrayIndex;

   DECLARE_IO_ARRAY( __LEVEL_IN );
   DECLARE_IO_ARRAY( __LEVEL_OUT );
   DECLARE_STRING_STRUCT( S2_dynamic_preset2, __PATH$ );
   DECLARE_STRING_STRUCT( S2_dynamic_preset2, __FILENAME$ );
};

START_NVRAM_VAR_STRUCT( S2_dynamic_preset2 )
{
   DECLARE_STRING_STRUCT( S2_dynamic_preset2, __M_SFILENAME );
   unsigned short __G_IMAXLEVELS;
};



#endif //__S2_DYNAMIC_PRESET2_H__

