[BEGIN]
  Version=1
[END]
[BEGIN]
  ObjTp=FSgntr
  Sgntr=CresSPlus
  RelVrs=1
  IntStrVrs=1
  SPlusVrs=3.01.20
  InclDatVrs=1.15
  CrossCplrVrs=1.1
[END]
[BEGIN]
  ObjTp=Hd
  Cmn1=Does "vacation mode" lighting schedule for lighting, where lighting\\
  Cmn2=dim or switch levels are recorded at intervals over a time period||1
  Cmn3=of\\up to 14 days, while the home is occupied. Then the playback||1
  Cmn4=mode\\can be activated and the lighting levels are played back from||1
  Cmn5=the\\recorded files to simulate that the home is occupied.\\\\Initialize||1
  Cmn6=the program when it is first loaded by pulsing "InitOneTime". \\
  Cmn7=Connect as many analog dim levels as desired to the array DimLevels.
  Cmn8=\\Connect as many switched levels as desired to the array Switched||1
  Cmn9=Levels.\\Set up the RecordingIntervalInMinutes to a number between||1
  Cmn10=5 and 60, inclusive.\\If Record2WkPeriod is high, up to 14 days||1
  Cmn11=of data are recorded; otherwise,\\the max is 7 days. The path$ is||1
  Cmn12=the path of the files representing the\\recorded data. Usually it||1
  Cmn13=would be a folder on compact flash, but could\\be NVRAM disk. If||1
  Cmn14=VaryPlayback is low, the data in the files is played back\\at the||1
  Cmn15=exact time that is recorded in the files. Otherwise, it will be\\
  Cmn16=randomly varied between the times preceding and following it.\\\\
  Cmn17=When "StartRecording" goes high, the levels are immediately written||1
  Cmn18=to a\\temporary file. New data is added every time the recording||1
  Cmn19=interval is up.\\Each data time represents #bytes = 9 + 2*(#dim||1
  Cmn20=levels) + (#switched levels).\\The name of the temp file is learn_0.
  Cmn21=dat. At midnight, the file is copied to\\the appropriate permanent||1
  Cmn22=file name which is learn<day_of_week>w<week_number>.dat,\\e.g. learn5w1.
  Cmn23=dat is Thursday (Sunday=1,etc) of the first recorded week.\\\\Recording||1
  Cmn24=can be stopped at any time. If DontCopyDataFromSavedFile is 0 \\
  Cmn25=(the default), data from any previously existing file for that day||1
  Cmn26=is added to\\the end if the timestamp is later than the current||1
  Cmn27=time. Similarly, when\\recording is begun, data from any previously||1
  Cmn28=existing file for that day is\\added to the beginning of the temp||1
  Cmn29=file if the timestamp is earlier than the \\current time.\\\\When||1
  Cmn30="StartPlayback" goes high, the appropriate recording file is located||1
  Cmn31=and\\the appropriate lighting levels are output at the appropriate||1
  Cmn32=time, until Stop\\goes high. Data from the same day of the week||1
  Cmn33=is played back, e.g. playing\\back on a Sunday will try to locate||1
  Cmn34=Sunday recorded data. If it can't, it will\\try to locate either||1
  Cmn35=weekend data or weekday data, then it will try any recording\\file||1
  Cmn36=that it can find, before giving up. If a 2 week cycle was specified,||1
  Cmn37=the second\\week of playback will use the second week of recorded||1
  Cmn38=data, and only fall back\\to the first week if it can't locate that||1
  Cmn39=data.\\\\Current_Mode is feedback saying whether you are recording(1),||1
  Cmn40=playing back(2)\\or neither(0).\\\\REVISION HISTORY\\================\\
  Cmn41=\\v1.0.3\\------\\-added code to check that logic processor has||1
  Cmn42=actually initialized before attempting\\ to execute main loop. Without||1
  Cmn43=this, large programs that took a little while to initialize\\ could||1
  Cmn44=encounter problems at startup.\\\\v1.0.2\\------\\-improved behavior||1
  Cmn45=to no longer require recorded data in order to playback. In the\\
  Cmn46=||1absence of recorded data, the scheduler will create random light||1
  Cmn47=levels, and attempt\\ to maintain overall house lighting levels||1
  Cmn48=based on time of day (e.g. lights are more\\ often to go off than||1
  Cmn49=on in the middle of the night).\\-save current operating mode to||1
  Cmn50=disk to recall on startup even if a new program is loaded\\-changed||1
  Cmn51=default startup mode to record, from stop\\-removed error messages||1
  Cmn52=that would appear if certain files were missing, since this\\ was||1
  Cmn53=an expected condition for new systems\\-removed error message on||1
  Cmn54=startup that NVRAM was an invalid directory\\\\v1.0.1\\------\\-
  Cmn55=initial public release  \\
[END]
[BEGIN]
  InputCue1=InitOneTime
  InputSigType1=Digital
  InputCue2=StartRecording
  InputSigType2=Digital
  InputCue3=StartPlayback
  InputSigType3=Digital
  InputCue4=Stop
  InputSigType4=Digital
  InputCue5=Record2WkPeriod
  InputSigType5=Digital
  InputCue6=DontCopyDataFromSavedFile
  InputSigType6=Digital
  InputCue7=VaryPlayback
  InputSigType7=Digital
  InputCue8=SwitchedLevels[#]
  InputSigType8=Digital
  OutputCue1=PlaybackSwitchedLevels[#]
  OutputSigType1=Digital
  InputList2Cue1=path$
  InputList2SigType1=Serial
  InputList2Cue2=RecordingIntervalInMinutes
  InputList2SigType2=Analog
  InputList2Cue3=DimLevels[#]
  InputList2SigType3=Analog
  OutputList2Cue1=Current_Mode
  OutputList2SigType1=Analog
  OutputList2Cue2=PlaybackDimLevels[#]
  OutputList2SigType2=Analog
  ObjTp=Symbol
  Exclusions=1,19,20,21,88,89,167,168,179,216,225,248,249,266,310,
  Name=Vacation Scheduler v1.0.3 (cm)
  SmplCName=learning scheduler.csp
  Code=1
  SysRev5=1.019
  SMWRev=2.02.00
  MinVariableInputs=8
  MaxVariableInputs=507
  MinVariableInputsList2=3
  MaxVariableInputsList2=502
  MinVariableOutputs=1
  MaxVariableOutputs=500
  MinVariableOutputsList2=2
  MaxVariableOutputsList2=501
  Expand=expand_randomly
  ProgramTree=Logic
  SymbolTree=6
  Hint=
  HelpID= 
  Render=4
  Smpl-C=16
  CompilerCode=-48
  CompilerParamCode=27
  CompilerParamCode5=14
  NumFixedParams=1
  NVStorage=10
  ParamSigType1=String
  ParamCue1=[Reference Name]
  SmplCInputCue1=o#
  SmplCOutputCue1=i#
  SmplCInputList2Cue1=an#
  SmplCOutputList2Cue1=ai#
  SPlus2CompiledName=S2_learning_scheduler
  SymJam=NonExclusive
[END]
